﻿cPet = {
	isActive = false,
	name = nil,
	level = nil,
	xp = nil,
	maxXP = nil,
	maxLevel = nil,
	killList = nil,
	killAverage = nil,
	killListLength = 10,
	
	nextMobName = nil, -- The name of the next mob to be announced... Dirty workaround :/
	
	Initialize = function(self, killAverage)
		-- Initialize average list variables
		self.killList = { }
		self.killAverage = nil
		
		-- Make sure the player has a pet
		local hasUI, isHunterPet = HasPetUI();
		if not hasUI or not isHunterPet then
			self.isActive = false;
		else
			-- Update the object with the data for the current pet
			self:Update()
			if killAverage ~= nil and tonumber(killAverage) > 0 then
				-- Make sure the average passed isn't hugely of target (3x the estimate is allowed)
				if killAverage > (PetXP(cPlayer.level, self.level, cPlayer.level) * 3) then
					table.insert(self.killList, PetXP(cPlayer.level, self.level, cPlayer.level))
				else
					table.insert(self.killList, tonumber(killAverage))
				end
			end
		end
	end,
	
	-- Updates the pet xp info
	Update = function(self)
		local oldXP, gainedXP
		oldXP = self.xp
	
		self.name = UnitName("pet")
		self.level = UnitLevel('pet')
		self.maxLevel = cPlayer.level or UnitLevel('player')
		self.xp, self.maxXP = GetPetExperience()
		
		if self.level < self.maxLevel then
			self.isActive = true
		else
			self.isActive = false;
		end
		
		if oldXP then
			gainedXP = self.xp - oldXP
			-- Make sure this falls within realistic gains from a kill.
			-- Otherwise this may be an initialization update.
			if gainedXP < (PetXP(cPlayer.level, self.level, cPlayer.level) * 3) then
				self:AddKill(gainedXP)
			end
		end
		
		return gainedXP or 0
	end,
	
	AddKill = function(self, xp)
		if not self.killList then
			self.killList = { }
		end
		if xp > 0 then
			self.killAverage = nil
			table.insert(self.killList, 1, xp)
			if(# self.killList > self.killListLength) then
				table.remove(self.killList)
			end
		end
	end,
	
	GetAverageKillXP = function(self)
		if self.killAverage == nil then
			if(# self.killList > 0) then
				local total = 0
				for index, value in ipairs(self.killList) do
					total = total + (value or 0)
				end
				if total > 0 then
					self.killAverage = (total / (# self.killList))
				else
					self.killAverage = PetXP(cPlayer.level, self.level, cPlayer.level)
					self.killList = { }
					table.insert(self.killList, tonumber(self.killAverage))
				end
			else
				self.killAverage = PetXP(cPlayer.level, self.level, cPlayer.level)
			end
		end
		return self.killAverage
	end,
	
	GetAverageKillsRemaining = function(self)
		local xpRemaining, killsRemaining;

		xpRemaining = (self.maxXP or 0) - (self.xp or 0)
		killsRemaining = ceil(xpRemaining / self:GetAverageKillXP());
		
		return killsRemaining;
	end,
	
	ClearKillList = function (self, initialValue)
		self.killList = { }
        if initialValue ~= nil and tonumber(initialValue) > 0 then
            table.insert(self.killList, tonumber(initialValue))
        end
	end,
	
	GetMobName = function(self)
		if self.nextMobName then
			local name = self.nextMobName
			self.nextMobName = nil
			return name
		else
			return strlower(L["Kills"])
		end
	end,
	
	GetName = function(self)
		if not self.name then
			self.name = UnitName("pet")
		end
		return self.name -- /run cDisplay:Print(cPet:GetName())
	end
};